#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <fakemeta_util>
#include <hamsandwich>
//#include <zombie_theheroex>
#include <cstrike>
#include <xs>
#include <zombieplague>

#define PLUGIN "[Zombie: The Hero] Melee Weapon: Skull-Axe (A.K.A: Skull-9)"
#define VERSION "2.0"
#define AUTHOR "Dias"

#define RADIUS_SLASH 110.0
#define RADIUS_STAB 110.0
#define DISTANCE_FROM_ATTACK 48.0

#define DAMAGE_SLASH 400.0
#define DAMAGE_STAB 800.0

new const v_model[] = "models/v_stormgianttw.mdl"
new const p_model[] = "models/p_stormgianttw.mdl"

new const draw_sound[] = "weapons/stormgiant_draw.wav"
new const hit_sound[] = "weapons/stormgiant_hit1.wav"
new const miss_sound[] = "weapons/stormgiant_stab_miss.wav"

new const exp_spr[] = "sprites/ef_stormgianttw.spr"

new g_stormgiant
new g_had_stormgiant[33], g_can_attack
const m_szAnimExtention = 492
new g_exp_sprid
new g_draw
#define is_valid_entity(%0) (pev_valid(%0) == 2)

#define TASK_STARTSLASH 342423
#define TASK_SLASHING 423453
#define TASK_STABING 423423
#define TASK_DRAW 423422
enum
{
	KNIFE_ANIM_IDLE = 0,
	KNIFE_ANIM_SLASH1,
	KNIFE_ANIM_SLASH2,
	KNIFE_ANIM_DRAW,
	KNIFE_ANIM_STAB_HIT,
	KNIFE_ANIM_STAB_MISS,
	KNIFE_ANIM_MIDSLASH1,
	KNIFE_ANIM_MIDSLASH2
}

enum
{
	STORMGIANT_ANIM_IDLE = 0,
	STORMGIANT_ANIM_DRAWATTACK,
	STORMGIANT_ANIM_DRAWATTACKHIT,
	STORMGIANT_ANIM_DRAW,
	STORMGIANT_ANIM_STARTSLASH,
	STORMGIANT_ANIM_SLASHHIT,
	STORMGIANT_ANIM_SLASHMISS,
	STORMGIANT_ANIM_STARTSTAB,
	STORMGIANT_ANIM_STABHIT,
	STORMGIANT_ANIM_STABMISS
}

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_event("CurWeapon", "Event_CurWeapon", "be", "1=1")
	
	register_forward(FM_EmitSound, "fw_EmitSound")
	register_forward(FM_CmdStart, "fw_CmdStart")
	register_forward(FM_TraceLine, "fw_TraceLine")
	register_forward(FM_TraceHull, "fw_TraceHull")		
	RegisterHam(Ham_Weapon_WeaponIdle, "weapon_knife", "fw_Weapon_WeaponIdle_Post", 1)
	register_clcmd("say storm","get_stormgiant")
	//g_skullaxe = zbheroex_register_weapon("Skull-9", WEAPON_MELEE, CSW_KNIFE, 13999)
	//RegisterHam(Ham_CS_Weapon_SendWeaponAnim, "weapon_knife", "fw_Knife_SendAnim", 1)
}

public plugin_precache()
{
	engfunc(EngFunc_PrecacheModel, v_model)
	engfunc(EngFunc_PrecacheModel, p_model)
	
	engfunc(EngFunc_PrecacheSound, draw_sound)
	engfunc(EngFunc_PrecacheSound, hit_sound)
	engfunc(EngFunc_PrecacheSound, miss_sound)
	g_exp_sprid = engfunc(EngFunc_PrecacheModel, exp_spr)
	
}

public Player_Spawn(id)
{
	remove_stormgiant(id)
}

public fw_PlayerKilled(id)
{
	remove_stormgiant(id)
}

public zp_user_infected_pre(id) remove_stormgiant(id)
public zp_user_infected_post(id) remove_stormgiant(id)

public plugin_natives()
{
	register_native("get_stormgiant", "native_get_stormgiant", 1)
}

public native_get_stormgiant(id)
{
        get_stormgiant(id)
}

public get_stormgiant(id)
{
	g_had_stormgiant[id] = 1
	g_draw = 1
	if(get_user_weapon(id) == CSW_KNIFE) 
	{
		Event_CurWeapon(id)
	}
}

public remove_stormgiant(id)
{
	g_had_stormgiant[id] = 0
	
	remove_task(id+TASK_STARTSLASH)
	remove_task(id+TASK_SLASHING)
	remove_task(id+TASK_STABING)
	remove_task(id+TASK_DRAW)
}
/*public zbheroex_weapon_bought(id, ItemID)
{
	if(ItemID == g_skullaxe) get_skullaxe(id)
}

public zbheroex_weapon_remove(id, ItemID)
{
	if(ItemID == g_skullaxe) remove_skullaxe(id)
}*/

public Event_CurWeapon(id)
{
	if(!is_user_alive(id))
		return 1
	if(get_user_weapon(id) != CSW_KNIFE)
		return 1
	if(!g_had_stormgiant[id])
		return 1
		
	set_pev(id, pev_viewmodel2, v_model)
	set_pev(id, pev_weaponmodel2, p_model)
	g_draw = 1
	set_task(0.1, "Start_DrawAttackNow", id+TASK_DRAW)
	set_task(0.4,"no_draw",id) // reset
	set_pdata_string(id, (492) * 4, "skullaxe", -1 , 20)
	
	return 0
}
public no_draw(id)
{
	g_draw = 1
	
}
public fw_Weapon_WeaponIdle_Post(ent)
{
	static id; id = pev(ent, pev_owner)
	if(!is_user_alive(id))
		return HAM_IGNORED
	if(!g_had_stormgiant[id])
		return HAM_IGNORED
	set_pdata_string(id, m_szAnimExtention * 4, "skullaxe", -1 , 20)
	
	if(get_pdata_float(ent, 48, 4) <= 0.25) 
	{
		set_weapon_anim(id, STORMGIANT_ANIM_IDLE)
		set_pdata_float(ent, 48, 20.0, 4)
	}
	
	return HAM_IGNORED
}
public fw_EmitSound(id, channel, const sample[], Float:volume, Float:attn, flags, pitch)
{
	if(!is_user_connected(id))
		return FMRES_IGNORED
	if(get_user_weapon(id) != CSW_KNIFE || !g_had_stormgiant[id])
		return FMRES_IGNORED
		
	if(sample[8] == 'k' && sample[9] == 'n' && sample[10] == 'i')
	{
		if(sample[14] == 's' && sample[15] == 'l' && sample[16] == 'a')
			return FMRES_SUPERCEDE
		if (sample[14] == 'h' && sample[15] == 'i' && sample[16] == 't') // hit
		{
			if (sample[17] == 'w') // wall
				return FMRES_SUPERCEDE
			else
				return FMRES_SUPERCEDE
		}
		if (sample[14] == 's' && sample[15] == 't' && sample[16] == 'a') // stab
			return FMRES_SUPERCEDE;
	}
	
	return FMRES_IGNORED
}

public fw_CmdStart(id, uc_handle, seed)
{
	if (!is_user_alive(id)) 
		return
	if(get_user_weapon(id) != CSW_KNIFE)
		return
	if(!g_had_stormgiant[id])
		return
	
	static ent
	ent = find_ent_by_owner(-1, "weapon_knife", id)
	
	if(!pev_valid(ent))
		return
	if(get_pdata_float(ent, 46, 4) > 0.0 || get_pdata_float(ent, 47, 4) > 0.0) 
		return
	
	static CurButton , OldButton
	CurButton = get_uc(uc_handle, UC_Buttons)
	OldButton = (pev(id, pev_oldbuttons) & IN_ATTACK2)
	if (CurButton & IN_ATTACK)
	{
		set_uc(uc_handle, UC_Buttons, CurButton & ~IN_ATTACK)
		
		ExecuteHamB(Ham_Weapon_PrimaryAttack, ent)
		
		set_weapons_timeidle(id, 1.1)
		set_player_nextattack(id, 1.1)
		
		set_weapon_anim(id, STORMGIANT_ANIM_STARTSLASH)
		set_task(1.0, "Start_SlashNow", id+TASK_STARTSLASH)
	} else if (CurButton & IN_ATTACK2) {
		set_uc(uc_handle, UC_Buttons, CurButton & ~IN_ATTACK2)
		if(/*task_exists(id+TASK_DRAW) &&*/ g_draw && OldButton)
		{
			set_task(0.2, "Start_StabNow", id+TASK_STABING)
			g_draw = 0
		}
		else
		{
			set_uc(uc_handle, UC_Buttons, CurButton & ~IN_ATTACK2)
			
			ExecuteHamB(Ham_Weapon_SecondaryAttack, ent)
			
			set_weapons_timeidle(id, 0.9)
			set_player_nextattack(id, 0.9)
			
			set_weapon_anim(id, STORMGIANT_ANIM_STARTSTAB)
			set_task(0.8, "Start_StabNow", id+TASK_STABING)
				
		}
	}
}

public fw_TraceLine(Float:vector_start[3], Float:vector_end[3], ignored_monster, id, handle)
{
	if (!is_user_alive(id))
		return FMRES_IGNORED
	//if(zbheroex_get_user_zombie(id))
		return FMRES_IGNORED		
	if (get_user_weapon(id) != CSW_KNIFE)
		return FMRES_IGNORED
	if(!g_had_stormgiant[id])
		return FMRES_IGNORED
	
	static Float:vecStart[3], Float:vecEnd[3], Float:v_angle[3], Float:v_forward[3], Float:view_ofs[3], Float:fOrigin[3]
	
	pev(id, pev_origin, fOrigin)
	pev(id, pev_view_ofs, view_ofs)
	xs_vec_add(fOrigin, view_ofs, vecStart)
	pev(id, pev_v_angle, v_angle)
	
	engfunc(EngFunc_MakeVectors, v_angle)
	get_global_vector(GL_v_forward, v_forward)

	xs_vec_mul_scalar(v_forward, 0.0, v_forward)
	xs_vec_add(vecStart, v_forward, vecEnd)
	
	engfunc(EngFunc_TraceLine, vecStart, vecEnd, ignored_monster, id, handle)
	
	return FMRES_SUPERCEDE
}

public fw_TraceHull(Float:vector_start[3], Float:vector_end[3], ignored_monster, hull, id, handle)
{
	if (!is_user_alive(id))
		return FMRES_IGNORED
	//if(zbheroex_get_user_zombie(id))
		return FMRES_IGNORED
	if (get_user_weapon(id) != CSW_KNIFE)
		return FMRES_IGNORED
	if(!g_had_stormgiant[id])
		return FMRES_IGNORED
	
	static Float:vecStart[3], Float:vecEnd[3], Float:v_angle[3], Float:v_forward[3], Float:view_ofs[3], Float:fOrigin[3]
	
	pev(id, pev_origin, fOrigin)
	pev(id, pev_view_ofs, view_ofs)
	xs_vec_add(fOrigin, view_ofs, vecStart)
	pev(id, pev_v_angle, v_angle)
	
	engfunc(EngFunc_MakeVectors, v_angle)
	get_global_vector(GL_v_forward, v_forward)

	xs_vec_mul_scalar(v_forward, 0.0, v_forward)
	xs_vec_add(vecStart, v_forward, vecEnd)
	
	engfunc(EngFunc_TraceHull, vecStart, vecEnd, ignored_monster, hull, id, handle)
	
	return FMRES_SUPERCEDE
}
public Start_DrawAttackNow(id)
{
	id -= TASK_DRAW
	
	if(!is_user_alive(id)) 
		return
	if(get_user_weapon(id) != CSW_KNIFE || !g_had_stormgiant[id])
		return	
		
	if(!Check_Draw(id, 1))
	{
		set_weapon_anim(id, STORMGIANT_ANIM_DRAWATTACK)
		EmitSound(id, CHAN_WEAPON, miss_sound)
		
		set_task(0.1, "Draw_Miss", id+TASK_DRAW)
		
	} else {
		set_weapon_anim(id, STORMGIANT_ANIM_DRAWATTACKHIT)
		
		set_task(0.1, "Draw_Hit", id+TASK_DRAW)
	}
	
}
public Draw_Miss(id)
{
	id -= TASK_DRAW
	
	if(!is_user_alive(id)) 
		return
	if(get_user_weapon(id) != CSW_KNIFE || !g_had_stormgiant[id])
		return	
	
	set_weapons_timeidle(id, 1.0)
	set_player_nextattack(id, 1.0)
	
}

public Draw_Hit(id)
{
	id -= TASK_DRAW
	
	if (!is_user_alive(id)) 
		return
	if(get_user_weapon(id) != CSW_KNIFE || !g_had_stormgiant[id])
		return	
	
	set_weapons_timeidle(id, 1.0)
	set_player_nextattack(id, 1.0)

	Check_Draw(id, 0)
}
public Start_SlashNow(id)
{
	id -= TASK_STARTSLASH
	
	if(!is_user_alive(id)) 
		return
	if(get_user_weapon(id) != CSW_KNIFE || !g_had_stormgiant[id])
		return	
		
	if(!Check_Slash(id, 1))
	{
		set_weapon_anim(id, STORMGIANT_ANIM_SLASHMISS)
		EmitSound(id, CHAN_WEAPON, miss_sound)
		
		set_task(0.1, "Slash_Miss", id+TASK_SLASHING)
		
	} else {
		set_weapon_anim(id, STORMGIANT_ANIM_SLASHHIT)
		
		set_task(0.1, "Slash_Hit", id+TASK_SLASHING)
	}
}
public Slash_Miss(id)
{
	id -= TASK_SLASHING
	
	if(!is_user_alive(id)) 
		return
	if(get_user_weapon(id) != CSW_KNIFE || !g_had_stormgiant[id])
		return	
	
	set_weapons_timeidle(id, 1.0)
	set_player_nextattack(id, 1.0)
}

public Slash_Hit(id)
{
	id -= TASK_SLASHING
	
	if (!is_user_alive(id)) 
		return
	if(get_user_weapon(id) != CSW_KNIFE || !g_had_stormgiant[id])
		return	
	
	set_weapons_timeidle(id, 1.0)
	set_player_nextattack(id, 1.0)

	Check_Slash(id, 0)
}
public Start_StabNow(id)
{
	id -= TASK_STABING
	
	if (!is_user_alive(id)) 
		return
	if(get_user_weapon(id) != CSW_KNIFE || !g_had_stormgiant[id])
		return		
	
	if(!Check_Draw(id, 1))
	{
		set_weapon_anim(id, STORMGIANT_ANIM_STABMISS)
		EmitSound(id, CHAN_WEAPON, miss_sound)
		
		set_task(0.1, "Stab_Miss", id+TASK_STABING)
		
	} else {
		set_weapon_anim(id, STORMGIANT_ANIM_STABHIT)
		
		set_task(0.1, "Stab_Hit", id+TASK_STABING)
	}
}
public Stab_Miss(id)
{
	id -= TASK_STABING
	
	if(!is_user_alive(id)) 
		return
	if(get_user_weapon(id) != CSW_KNIFE || !g_had_stormgiant[id])
		return	
	
	set_weapons_timeidle(id, 1.0)
	set_player_nextattack(id, 1.0)
}

public Stab_Hit(id)
{
	id -= TASK_STABING
	
	if (!is_user_alive(id)) 
		return
	if(get_user_weapon(id) != CSW_KNIFE || !g_had_stormgiant[id])
		return	
	
	set_weapons_timeidle(id, 1.0)
	set_player_nextattack(id, 1.0)

	Check_Stab(id, 0)
}
public Check_Slash(id, First_Check)
{
	#define MAX_POINT 4
	static Float:Max_Distance, Float:Point[MAX_POINT][3], Float:TB_Distance
	
	Max_Distance = RADIUS_SLASH
	TB_Distance = Max_Distance / float(MAX_POINT)
	
	static Float:VicOrigin[3], Float:MyOrigin[3]
	pev(id, pev_origin, MyOrigin)
	
	for(new i = 0; i < MAX_POINT; i++)
		get_position(id, TB_Distance * (i + 1), 0.0, 0.0, Point[i])
		
	static Have_Victim; Have_Victim = 0
	static ent
	ent = fm_get_user_weapon_entity(id, get_user_weapon(id))
		
	if(!pev_valid(ent))
		return 0
		
	for(new i = 0; i < get_maxplayers(); i++)
	{
		if(!is_user_alive(i))
			continue
		if(id == i)
			continue
		//if(zb3_get_user_zombie(i))
		//	continue
		if(entity_range(id, i) > Max_Distance)
			continue
	
		pev(i, pev_origin, VicOrigin)
		if(is_wall_between_points(MyOrigin, VicOrigin, id))
			continue
			
		if(get_distance_f(VicOrigin, Point[0]) <= DISTANCE_FROM_ATTACK
		|| get_distance_f(VicOrigin, Point[1]) <= DISTANCE_FROM_ATTACK
		|| get_distance_f(VicOrigin, Point[2]) <= DISTANCE_FROM_ATTACK
		|| get_distance_f(VicOrigin, Point[3]) <= DISTANCE_FROM_ATTACK)
		{
			if(!Have_Victim) Have_Victim = 1
			if(!First_Check && cs_get_user_team(id) != cs_get_user_team(i)) 
			{
				do_attack(id, i, ent, DAMAGE_SLASH)
				hook_ent2(ent, VicOrigin, 3080.0, 2)
			}
		}
		static TE_FLAG
		
		TE_FLAG |= TE_EXPLFLAG_NODLIGHTS
		TE_FLAG |= TE_EXPLFLAG_NOSOUND
		TE_FLAG |= TE_EXPLFLAG_NOPARTICLES
		
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_EXPLOSION)
		engfunc(EngFunc_WriteCoord, VicOrigin[0])
		engfunc(EngFunc_WriteCoord, VicOrigin[1])
		engfunc(EngFunc_WriteCoord, VicOrigin[2])
		write_short(g_exp_sprid)
		write_byte(5)
		write_byte(15)
		write_byte(TE_FLAG)
		message_end()
		
		// DLight
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(27)
		engfunc(EngFunc_WriteCoord, VicOrigin[0])
		engfunc(EngFunc_WriteCoord, VicOrigin[1])
		engfunc(EngFunc_WriteCoord, VicOrigin[2])
		write_byte(20)
		write_byte(240)
		write_byte(20)
		write_byte(20)
		write_byte(10)
		write_byte(60)
		message_end()
		
		emit_sound(id, CHAN_AUTO, hit_sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	}	
	
	if(Have_Victim)
		return 1
	else
		return 0
	
	return 0
}	

public Check_Stab(id, First_Check)
{
	#define MAX_POINT 4
	static Float:Max_Distance, Float:Point[MAX_POINT][3], Float:TB_Distance
	
	Max_Distance = RADIUS_STAB
	TB_Distance = Max_Distance / float(MAX_POINT)
	
	static Float:VicOrigin[3], Float:MyOrigin[3]
	pev(id, pev_origin, MyOrigin)
	
	for(new i = 0; i < MAX_POINT; i++)
		get_position(id, TB_Distance * (i + 1), 0.0, 0.0, Point[i])
		
	static Have_Victim; Have_Victim = 0
	static ent
	ent = fm_get_user_weapon_entity(id, get_user_weapon(id))
		
	if(!pev_valid(ent))
		return 0
	for(new i = 0; i < get_maxplayers(); i++)
	{
		if(!is_user_alive(i))
			continue
		if(id == i)
			continue
		if(entity_range(id, i) > Max_Distance)
			continue
	
		pev(i, pev_origin, VicOrigin)
		if(is_wall_between_points(MyOrigin, VicOrigin, id))
			continue
			
		if(get_distance_f(VicOrigin, Point[0]) <= (DISTANCE_FROM_ATTACK * 2.0)
		|| get_distance_f(VicOrigin, Point[1]) <= (DISTANCE_FROM_ATTACK * 2.0)
		|| get_distance_f(VicOrigin, Point[2]) <= (DISTANCE_FROM_ATTACK * 2.0)
		|| get_distance_f(VicOrigin, Point[3]) <= (DISTANCE_FROM_ATTACK * 2.0))
		{
			if(!Have_Victim) Have_Victim = 1
			if(!First_Check && cs_get_user_team(id) != cs_get_user_team(i)) 
			{
				do_attack(id, i, ent, DAMAGE_STAB)
				hook_ent2(ent, VicOrigin, 3080.0, 2)
			}
		}
		static TE_FLAG
		
		TE_FLAG |= TE_EXPLFLAG_NODLIGHTS
		TE_FLAG |= TE_EXPLFLAG_NOSOUND
		TE_FLAG |= TE_EXPLFLAG_NOPARTICLES
		
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_EXPLOSION)
		engfunc(EngFunc_WriteCoord, VicOrigin[0])
		engfunc(EngFunc_WriteCoord, VicOrigin[1])
		engfunc(EngFunc_WriteCoord, VicOrigin[2])
		write_short(g_exp_sprid)
		write_byte(5)
		write_byte(15)
		write_byte(TE_FLAG)
		message_end()
		
		// DLight
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(27)
		engfunc(EngFunc_WriteCoord, VicOrigin[0])
		engfunc(EngFunc_WriteCoord, VicOrigin[1])
		engfunc(EngFunc_WriteCoord, VicOrigin[2])
		write_byte(20)
		write_byte(240)
		write_byte(20)
		write_byte(20)
		write_byte(10)
		write_byte(60)
		message_end()
		
		emit_sound(id, CHAN_AUTO, hit_sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	}	
	
	if(Have_Victim)
		return 1
	else
		return 0
	
	return 0
}
public Check_Draw(id, First_Check)
{
	#define MAX_POINT 4
	static Float:Max_Distance, Float:Point[MAX_POINT][3], Float:TB_Distance
	
	Max_Distance = RADIUS_SLASH
	TB_Distance = Max_Distance / float(MAX_POINT)
	
	static Float:VicOrigin[3], Float:MyOrigin[3]
	pev(id, pev_origin, MyOrigin)
	
	for(new i = 0; i < MAX_POINT; i++)
		get_position(id, TB_Distance * (i + 1), 0.0, 0.0, Point[i])
		
	static Have_Victim; Have_Victim = 0
	static ent
	ent = fm_get_user_weapon_entity(id, get_user_weapon(id))
		
	if(!pev_valid(ent))
		return 0
		
	for(new i = 0; i < get_maxplayers(); i++)
	{
		if(!is_user_alive(i))
			continue
		if(id == i)
			continue
		//if(zb3_get_user_zombie(i))
		//	continue
		if(entity_range(id, i) > Max_Distance)
			continue
	
		pev(i, pev_origin, VicOrigin)
		if(is_wall_between_points(MyOrigin, VicOrigin, id))
			continue
			
		if(get_distance_f(VicOrigin, Point[0]) <= DISTANCE_FROM_ATTACK
		|| get_distance_f(VicOrigin, Point[1]) <= DISTANCE_FROM_ATTACK
		|| get_distance_f(VicOrigin, Point[2]) <= DISTANCE_FROM_ATTACK
		|| get_distance_f(VicOrigin, Point[3]) <= DISTANCE_FROM_ATTACK)
		{
			if(!Have_Victim) Have_Victim = 1
			if(!First_Check && cs_get_user_team(id) != cs_get_user_team(i)) 
			{
				do_attack(id, i, ent, DAMAGE_SLASH)
				hook_ent2(ent, VicOrigin, 3080.0, 2)
			}
		}
		static TE_FLAG
		
		TE_FLAG |= TE_EXPLFLAG_NODLIGHTS
		TE_FLAG |= TE_EXPLFLAG_NOSOUND
		TE_FLAG |= TE_EXPLFLAG_NOPARTICLES
		
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_EXPLOSION)
		engfunc(EngFunc_WriteCoord, VicOrigin[0])
		engfunc(EngFunc_WriteCoord, VicOrigin[1])
		engfunc(EngFunc_WriteCoord, VicOrigin[2])
		write_short(g_exp_sprid)
		write_byte(5)
		write_byte(15)
		write_byte(TE_FLAG)
		message_end()
		
		// DLight
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(27)
		engfunc(EngFunc_WriteCoord, VicOrigin[0])
		engfunc(EngFunc_WriteCoord, VicOrigin[1])
		engfunc(EngFunc_WriteCoord, VicOrigin[2])
		write_byte(20)
		write_byte(240)
		write_byte(20)
		write_byte(20)
		write_byte(10)
		write_byte(60)
		message_end()
		
		emit_sound(id, CHAN_AUTO, hit_sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	}	
	
	if(Have_Victim)
		return 1
	else
		return 0
	
	return 0
}	

/*
public Effect_Attack(id, ent, attacker, Float:Damage, Float:Dir[3], ptr, DamageType)
{
	if(!is_user_alive(id))
		return HAM_IGNORED
	if(get_user_weapon(id) != CSW_KNIFE || !g_had_skullaxe[id])
		return HAM_IGNORED
	static Float:VicOrigin[3], Float:MyOrigin[3]
	pev(id, pev_origin, MyOrigin)
	for(new i = 0; i < get_maxplayers(); i++)
	{
		if(!is_user_alive(i))
			continue
		if(id == i)
			continue
		if(entity_range(i, id) > float(random_float(RADIUS_SLASH,RADIUS_STAB)))
			continue
		
		pev(i, pev_origin, VicOrigin)
		if(is_wall_between_points(MyOrigin, VicOrigin, id))
			continue
		if(cs_get_user_team(id) == cs_get_user_team(i))
			continue
		hook_ent2(ent, VicOrigin, 3080.0, 2)
		
		static TE_FLAG
		
		TE_FLAG |= TE_EXPLFLAG_NODLIGHTS
		TE_FLAG |= TE_EXPLFLAG_NOSOUND
		TE_FLAG |= TE_EXPLFLAG_NOPARTICLES
		
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_EXPLOSION)
		engfunc(EngFunc_WriteCoord, VicOrigin[0])
		engfunc(EngFunc_WriteCoord, VicOrigin[1])
		engfunc(EngFunc_WriteCoord, VicOrigin[2])
		write_short(g_exp_sprid)
		write_byte(5)
		write_byte(30)
		write_byte(TE_FLAG)
		message_end()
		
		// DLight
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(27)
		engfunc(EngFunc_WriteCoord, VicOrigin[0])
		engfunc(EngFunc_WriteCoord, VicOrigin[1])
		engfunc(EngFunc_WriteCoord, VicOrigin[2])
		write_byte(20)
		write_byte(240)
		write_byte(20)
		write_byte(20)
		write_byte(10)
		write_byte(60)
		message_end()
		
		emit_sound(id, CHAN_AUTO, hit_sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	}
	return HAM_HANDLED
}
*/
stock hook_ent2(ent, Float:VicOrigin[3], Float:speed, type)
{
	static Float:fl_Velocity[3]
	static Float:EntOrigin[3]
	
	pev(ent, pev_origin, EntOrigin)
	static Float:distance_f
	distance_f = get_distance_f(EntOrigin, VicOrigin)
	
	new Float:fl_Time = distance_f / speed
	
	VicOrigin[2] -= 36.0
	
	if(type == 1)
	{
		fl_Velocity[0] = ((VicOrigin[0] - EntOrigin[0]) / fl_Time) * 1.5
		fl_Velocity[1] = ((VicOrigin[1] - EntOrigin[1]) / fl_Time) * 1.5
		fl_Velocity[2] = ((VicOrigin[2] - EntOrigin[2]) / fl_Time) * 1.5
	} else if(type == 2) {
		fl_Velocity[0] = ((EntOrigin[0] - VicOrigin[0]) / fl_Time) * 1.5
		fl_Velocity[1] = ((EntOrigin[1] - VicOrigin[1]) / fl_Time) * 1.5
		fl_Velocity[2] = ((EntOrigin[2] - VicOrigin[2]) / fl_Time) * 1.5
	}

	entity_set_vector(ent, EV_VEC_velocity, fl_Velocity)
}

do_attack(Attacker, Victim, Inflictor, Float:fDamage)
{
	fake_player_trace_attack(Attacker, Victim, fDamage)
	fake_take_damage(Attacker, Victim, fDamage, Inflictor)
}

fake_player_trace_attack(iAttacker, iVictim, &Float:fDamage)
{
	// get fDirection
	static Float:fAngles[3], Float:fDirection[3]
	pev(iAttacker, pev_angles, fAngles)
	angle_vector(fAngles, ANGLEVECTOR_FORWARD, fDirection)
	
	// get fStart
	static Float:fStart[3], Float:fViewOfs[3]
	pev(iAttacker, pev_origin, fStart)
	pev(iAttacker, pev_view_ofs, fViewOfs)
	xs_vec_add(fViewOfs, fStart, fStart)
	
	// get aimOrigin
	static iAimOrigin[3], Float:fAimOrigin[3]
	get_user_origin(iAttacker, iAimOrigin, 3)
	IVecFVec(iAimOrigin, fAimOrigin)
	
	// TraceLine from fStart to AimOrigin
	static ptr; ptr = create_tr2() 
	engfunc(EngFunc_TraceLine, fStart, fAimOrigin, DONT_IGNORE_MONSTERS, iAttacker, ptr)
	static pHit; pHit = get_tr2(ptr, TR_pHit)
	static iHitgroup; iHitgroup = get_tr2(ptr, TR_iHitgroup)
	static Float:fEndPos[3]; get_tr2(ptr, TR_vecEndPos, fEndPos)

	// get target & body at aiming
	static iTarget, iBody
	get_user_aiming(iAttacker, iTarget, iBody)
	
	// if aiming find target is iVictim then update iHitgroup
	if (iTarget == iVictim)
	{
		iHitgroup = iBody
	}
	
	// if ptr find target not is iVictim
	else if (pHit != iVictim)
	{
		// get AimOrigin in iVictim
		static Float:fVicOrigin[3], Float:fVicViewOfs[3], Float:fAimInVictim[3]
		pev(iVictim, pev_origin, fVicOrigin)
		pev(iVictim, pev_view_ofs, fVicViewOfs) 
		xs_vec_add(fVicViewOfs, fVicOrigin, fAimInVictim)
		fAimInVictim[2] = fStart[2]
		fAimInVictim[2] += get_distance_f(fStart, fAimInVictim) * floattan( fAngles[0] * 2.0, degrees )
		
		// check aim in size of iVictim
		static iAngleToVictim; iAngleToVictim = get_angle_to_target(iAttacker, fVicOrigin)
		iAngleToVictim = abs(iAngleToVictim)
		static Float:fDis; fDis = 2.0 * get_distance_f(fStart, fAimInVictim) * floatsin( float(iAngleToVictim) * 0.5, degrees )
		static Float:fVicSize[3]
		pev(iVictim, pev_size , fVicSize)
		if ( fDis <= fVicSize[0] * 0.5 )
		{
			// TraceLine from fStart to aimOrigin in iVictim
			static ptr2; ptr2 = create_tr2() 
			engfunc(EngFunc_TraceLine, fStart, fAimInVictim, DONT_IGNORE_MONSTERS, iAttacker, ptr2)
			static pHit2; pHit2 = get_tr2(ptr2, TR_pHit)
			static iHitgroup2; iHitgroup2 = get_tr2(ptr2, TR_iHitgroup)
			
			// if ptr2 find target is iVictim
			if ( pHit2 == iVictim && (iHitgroup2 != HIT_HEAD || fDis <= fVicSize[0] * 0.25) )
			{
				pHit = iVictim
				iHitgroup = iHitgroup2
				get_tr2(ptr2, TR_vecEndPos, fEndPos)
			}
			
			free_tr2(ptr2)
		}
		
		// if pHit still not is iVictim then set default HitGroup
		if (pHit != iVictim)
		{
			// set default iHitgroup
			iHitgroup = HIT_GENERIC
			
			new ptr3 = create_tr2() 
			engfunc(EngFunc_TraceLine, fStart, fVicOrigin, DONT_IGNORE_MONSTERS, iAttacker, ptr3)
			get_tr2(ptr3, TR_vecEndPos, fEndPos)
			
			// free ptr3
			free_tr2(ptr3)
		}
	}
	
	// set new Hit & Hitgroup & EndPos
	set_tr2(ptr, TR_pHit, iVictim)
	set_tr2(ptr, TR_iHitgroup, iHitgroup)
	set_tr2(ptr, TR_vecEndPos, fEndPos)
	
	//create_blood(fEndPos)
	
	// hitgroup multi fDamage
	static Float:fMultifDamage 
	switch(iHitgroup)
	{
		case HIT_HEAD: fMultifDamage  = 4.0
		case HIT_STOMACH: fMultifDamage  = 1.25
		case HIT_LEFTLEG: fMultifDamage  = 0.75
		case HIT_RIGHTLEG: fMultifDamage  = 0.75
		default: fMultifDamage  = 1.0
	}
	
	fDamage *= fMultifDamage
	
	// ExecuteHam
	fake_trake_attack(iAttacker, iVictim, fDamage, fDirection, ptr)
	
	// free ptr
	free_tr2(ptr)
}

stock fake_trake_attack(iAttacker, iVictim, Float:fDamage, Float:fDirection[3], iTraceHandle, iDamageBit = (DMG_NEVERGIB | DMG_BULLET))
{
	ExecuteHamB(Ham_TraceAttack, iVictim, iAttacker, fDamage, fDirection, iTraceHandle, iDamageBit)
}

stock fake_take_damage(iAttacker, iVictim, Float:fDamage, iInflictor, iDamageBit = (DMG_NEVERGIB | DMG_BULLET))
{
	ExecuteHamB(Ham_TakeDamage, iVictim, iInflictor, iAttacker, fDamage, iDamageBit)
}
stock get_angle_to_target(id, const Float:fTarget[3], Float:TargetSize = 0.0)
{
	new Float:fOrigin[3], iAimOrigin[3], Float:fAimOrigin[3], Float:fV1[3]
	pev(id, pev_origin, fOrigin)
	get_user_origin(id, iAimOrigin, 3) // end position from eyes
	IVecFVec(iAimOrigin, fAimOrigin)
	xs_vec_sub(fAimOrigin, fOrigin, fV1)
	
	new Float:fV2[3]
	xs_vec_sub(fTarget, fOrigin, fV2)
	
	new iResult = get_angle_between_vectors(fV1, fV2)
	
	if (TargetSize > 0.0)
	{
		new Float:fTan = TargetSize / get_distance_f(fOrigin, fTarget)
		new fAngleToTargetSize = floatround( floatatan(fTan, degrees) )
		iResult -= (iResult > 0) ? fAngleToTargetSize : -fAngleToTargetSize
	}
	
	return iResult
}

stock get_angle_between_vectors(const Float:fV1[3], const Float:fV2[3])
{
	new Float:fA1[3], Float:fA2[3]
	engfunc(EngFunc_VecToAngles, fV1, fA1)
	engfunc(EngFunc_VecToAngles, fV2, fA2)
	
	new iResult = floatround(fA1[1] - fA2[1])
	iResult = iResult % 360
	iResult = (iResult > 180) ? (iResult - 360) : iResult
	
	return iResult
}

stock EmitSound(id, chan, const file_sound[])
{
	if(!pev_valid(id))
		return
		
	emit_sound(id, chan, file_sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
}
	
stock get_position(ent, Float:forw, Float:right, Float:up, Float:vStart[])
{
	new Float:vOrigin[3], Float:vAngle[3], Float:vForward[3], Float:vRight[3], Float:vUp[3]
	
	pev(ent, pev_origin, vOrigin)
	pev(ent, pev_view_ofs,vUp) //for player
	xs_vec_add(vOrigin,vUp,vOrigin)
	pev(ent, pev_v_angle, vAngle) // if normal entity ,use pev_angles
	
	angle_vector(vAngle,ANGLEVECTOR_FORWARD,vForward) //or use EngFunc_AngleVectors
	angle_vector(vAngle,ANGLEVECTOR_RIGHT,vRight)
	angle_vector(vAngle,ANGLEVECTOR_UP,vUp)
	
	vStart[0] = vOrigin[0] + vForward[0] * forw + vRight[0] * right + vUp[0] * up
	vStart[1] = vOrigin[1] + vForward[1] * forw + vRight[1] * right + vUp[1] * up
	vStart[2] = vOrigin[2] + vForward[2] * forw + vRight[2] * right + vUp[2] * up
}
	
stock set_weapons_timeidle(id, Float:TimeIdle)
{
	if(!is_user_alive(id))
		return
		
	new entwpn = fm_get_user_weapon_entity(id, CSW_KNIFE)
	if (pev_valid(entwpn)) 
	{
		set_pdata_float(entwpn, 46, TimeIdle, 4)
		set_pdata_float(entwpn, 47, TimeIdle, 4)
		set_pdata_float(entwpn, 48, TimeIdle + 1.0, 4)
	}
}

stock is_wall_between_points(Float:start[3], Float:end[3], ignore_ent)
{
	static ptr
	ptr = create_tr2()

	engfunc(EngFunc_TraceLine, start, end, IGNORE_MONSTERS, ignore_ent, ptr)
	
	static Float:EndPos[3]
	get_tr2(ptr, TR_vecEndPos, EndPos)

	free_tr2(ptr)
	return floatround(get_distance_f(end, EndPos))
} 

stock set_player_nextattack(id, Float:nexttime)
{
	if(!is_user_alive(id))
		return
		
	const m_flNextAttack = 83
	set_pdata_float(id, m_flNextAttack, nexttime, 5)
}

stock set_weapon_anim(id, anim)
{
	if(!is_user_alive(id))
		return
		
	set_pev(id, pev_weaponanim, anim)
	
	message_begin(MSG_ONE_UNRELIABLE, SVC_WEAPONANIM, _, id)
	write_byte(anim)
	write_byte(0)
	message_end()	
}
